Debian Bug report logs - #443600
konqueror-nsplugins: Konqueror freezes with nspluginviewer at 100% CPU when loading web page

version graph

Package: konqueror-nsplugins; Maintainer for konqueror-nsplugins is Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>; Source for konqueror-nsplugins is src:kde-baseapps.

Reported by: Torquil Macdonald Sørensen <torquil@gmail.com>

Date: Sat, 22 Sep 2007 18:30:01 UTC

Severity: important

Tags: patch

Merged with 443399

Found in version kdebase/4:3.5.7-4

Done: Raúl Sánchez Siles <rss@barracuda.es>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Torquil Macdonald Sørensen <torquil@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Torquil Macdonald Sørensen <torquil@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: konqueror-nsplugins: Konqueror freezes with nspluginviewer at 100% CPU when loading web page
Date: Sat, 22 Sep 2007 20:21:31 +0200
Package: konqueror-nsplugins
Version: 4:3.5.7-4
Severity: normal

When trying to load www.dixonstaxfree.co.uk, konqueror freezes and the process
"nspluginviewer" takes 100% CPU (and 12-14MB RAM).

Best regards,
Torquil Sørensen

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (650, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.22-1-686 (SMP w/1 CPU core)
Locale: LANG=no_NO.UTF-8, LC_CTYPE=no_NO.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages konqueror-nsplugins depends on:
ii  kdelibs4c2a             4:3.5.7.dfsg.1-7 core libraries and binaries for al
ii  libc6                   2.6.1-5          GNU C Library: Shared libraries
ii  libgcc1                 1:4.2.1-5        GCC support library
ii  libqt3-mt               3:3.3.7-8        Qt GUI Library (Threaded runtime v
ii  libstdc++6              4.2.1-5          The GNU Standard C++ Library v3
ii  libx11-6                2:1.0.3-7        X11 client-side library
ii  libxt6                  1:1.0.5-3        X11 toolkit intrinsics library

konqueror-nsplugins recommends no packages.

-- no debconf information




Reply sent to Sune Vuorela <debian@pusling.com>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Torquil Macdonald Sørensen <torquil@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #10 received at 443600-done@bugs.debian.org (full text, mbox):

From: Sune Vuorela <debian@pusling.com>
To: 443600-done@bugs.debian.org
Subject: Re: Bug#443600: konqueror-nsplugins: Konqueror freezes with nspluginviewer at 100% CPU when loading web page
Date: Sat, 22 Sep 2007 21:29:11 +0200
[Message part 1 (text/plain, inline)]
On Saturday 22 September 2007, Torquil Macdonald Sørensen wrote:
> Package: konqueror-nsplugins
> Version: 4:3.5.7-4
> Severity: normal
>
> When trying to load www.dixonstaxfree.co.uk, konqueror freezes and the
> process "nspluginviewer" takes 100% CPU (and 12-14MB RAM).

Please go bug either adobe for their buggy flashplayer or the gtk people.

see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=440165 for details. We 
can't do much on kde side - but the real error is in adobe flash.

/Sune

-- 
Do you know how to open the code over the monitor to the laser floppy disk?

You need to forward from a level-23 ethernet window and then from the folder 
menu inside Excel XP you either can never enable the icon, or can't 
doubleclick on a RW CD cache for mounting a mailer to a BIOS.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Shai Berger <shai@platonix.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 443600@bugs.debian.org (full text, mbox):

From: Shai Berger <shai@platonix.com>
To: Debian Bug Tracking System <443600@bugs.debian.org>
Subject: konqueror-nsplugins: I think this was marked done prematurely
Date: Mon, 01 Oct 2007 03:06:13 +0200
Package: konqueror-nsplugins
Version: 4:3.5.7-4
Followup-For: Bug #443600


Hi,

This bug still bites hard. While it is true that Adobe
is ultimately to blame (as it is their code which uses
GTK without initializing it), nspluginviewer could initialize
GTK for their library, and allow debian/konqueror users
to view flash content (at the time of this posting, the
last entry on bug #440165 is from a user asking how to
work around it).

<wildguess gtk-knowledge="rumours">
It is even arguable that initializing an environment (like gtk)
is something only an app (like nspluginviewer) should do,
and not a library (like flash) -- even though I've seen it
argued that multiple GTK initialization is harmless.
</wildguess>

The Adobe bug does not seem to be insurmountable; iceweasel
manages to run flash successfully (that is, it bumps into
bugs other than this one).

Additionally, unless it is the flash library itself which
enters an infinite loop with this bug, nspluginviewer taking
100% CPU is undesired behavior; and whether or not nspluginviewer
could behave better, konqueror (a separate process) hanging 
seems like a worthy bug.

Hope this helps, 
	Shai.


-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.22-2-686 (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages konqueror-nsplugins depends on:
ii  kdelibs4c2a             4:3.5.7.dfsg.1-7 core libraries and binaries for al
ii  libc6                   2.6.1-5          GNU C Library: Shared libraries
ii  libgcc1                 1:4.2.1-5        GCC support library
ii  libqt3-mt               3:3.3.7-9        Qt GUI Library (Threaded runtime v
ii  libstdc++6              4.2.1-5          The GNU Standard C++ Library v3
ii  libx11-6                2:1.0.3-7        X11 client-side library
ii  libxt6                  1:1.0.5-3        X11 toolkit intrinsics library

konqueror-nsplugins recommends no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Sune Vuorela <Sune@vuorela.dk>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 443600@bugs.debian.org (full text, mbox):

From: Sune Vuorela <Sune@vuorela.dk>
To: Shai Berger <shai@platonix.com>
Cc: Debian Bug Tracking System <443600@bugs.debian.org>
Subject: Re: konqueror-nsplugins: I think this was marked done prematurely
Date: Sat, 6 Oct 2007 14:16:18 +0200
On Monday 01 October 2007, Shai Berger wrote:
> <wildguess gtk-knowledge="rumours">
> It is even arguable that initializing an environment (like gtk)
> is something only an app (like nspluginviewer) should do,
> and not a library (like flash) -- even though I've seen it
> argued that multiple GTK initialization is harmless.
> </wildguess>

nspluginviewer can't initialize any kind of environment that a plugin might or 
might not use. remember that this is plugins. If a plugin needs something 
special, then that something needs to do it.

> Additionally, unless it is the flash library itself which
> enters an infinite loop with this bug, nspluginviewer taking
> 100% CPU is undesired behavior; 

It is the flashplugins that does it.

either the bug could be fixud at it roots (=in adobe) or worked around 
where "special things" are needed (=gtk).

(And firefox and other gtk browsers works because they *tada* are gtk 
browsers - making konqueror a gtk browser isn't a choice we want to take)

/Sune


> and whether or not nspluginviewer 
> could behave better, konqueror (a separate process) hanging
> seems like a worthy bug.
>
> Hope this helps,
> 	Shai.
>
>
> -- System Information:
> Debian Release: lenny/sid
>   APT prefers unstable
>   APT policy: (500, 'unstable')
> Architecture: i386 (i686)
>
> Kernel: Linux 2.6.22-2-686 (SMP w/4 CPU cores)
> Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
> Shell: /bin/sh linked to /bin/bash
>
> Versions of packages konqueror-nsplugins depends on:
> ii  kdelibs4c2a             4:3.5.7.dfsg.1-7 core libraries and binaries
> for al ii  libc6                   2.6.1-5          GNU C Library: Shared
> libraries ii  libgcc1                 1:4.2.1-5        GCC support library
> ii  libqt3-mt               3:3.3.7-9        Qt GUI Library (Threaded
> runtime v ii  libstdc++6              4.2.1-5          The GNU Standard C++
> Library v3 ii  libx11-6                2:1.0.3-7        X11 client-side
> library ii  libxt6                  1:1.0.5-3        X11 toolkit intrinsics
> library
>
> konqueror-nsplugins recommends no packages.
>
> -- no debconf information



-- 
Do you know how might I do for uninstalling a desktop?

You neither can cancel a icon, nor should reset the periferic to the 
terminale, so that from MacOS 92 or from the tools inside Word you should 
never connect a ISA printer to cancel the space bar to a LCD folder over the 
laser 3D space bar.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Shai Berger <shai@platonix.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 443600@bugs.debian.org (full text, mbox):

From: Shai Berger <shai@platonix.com>
To: Sune Vuorela <Sune@vuorela.dk>
Cc: Debian Bug Tracking System <443600@bugs.debian.org>
Subject: Re: konqueror-nsplugins: I think this was marked done prematurely
Date: Sat, 06 Oct 2007 21:23:53 +0200
Hi Sune,

Thanks for your clarification about the reason for the 100% CPU. For the rest, 
however,

On Saturday 06 October 2007, Sune Vuorela wrote:
>
> nspluginviewer can't initialize any kind of environment that a plugin might
> or might not use. remember that this is plugins. If a plugin needs
> something special, then that something needs to do it.
>

Well, "ns" in nspluginviewer stands for NetScape, as far as I'm aware, so I 
doubt that GTK can be regarded as "something special". My understanding is 
that it should strive to make the plugin feel as if it is being run by 
netscape (or at least Gecko), and if that includes having an initialized GTK, 
then it is nspluginviewer's job to do so.

> either the bug could be fixud at it roots (=in adobe) or worked around
> where "special things" are needed (=gtk).
>
I beg to differ twice. Adobe wrote a library to work in GTK applications, so 
not initializing GTK in the library cannot be called a bug. From their point 
of view, the plugin works perfectly in all environments where it was designed 
to work.

GTK is also perfectly within their turf when they decide the meaning of their 
own API.

The only problem is when a non-gtk application insists it can call gtk 
libraries without initialization. Essentially, nspluginviewer has broken the 
API's contract, and is now paying the consequences (or rather, the users 
are).

> (And firefox and other gtk browsers works because they *tada* are gtk
> browsers - making konqueror a gtk browser isn't a choice we want to take)
>

While I understand and praise this desire for purity, I think it makes little 
sense when loading plugins designed for a GTK browser -- which is, after all, 
the whole point of nspluginviewer's existence, and more so, its existence as 
a separate entity. In essence, by choosing to use the plugin, the user has 
already told you they aren't interested in such purity.

I also understand the reluctance to include a dependency on GTK at the heart 
of KDE -- perhaps this means nspluginviewer should be taken out of kdebase. 
However, what you're doing now is try to tell the writers of plugins for 
Gecko-based browsers that there's a special, added requirement for their 
plug-in to work in konqueror. I think this won't fly.

And finally, you've ignored my point about konqueror hanging when this bug is 
triggered.

Hope this helps,

	Shai.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Kevin Krammer <kevin.krammer@gmx.at>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 443600@bugs.debian.org (full text, mbox):

From: Kevin Krammer <kevin.krammer@gmx.at>
To: Shai Berger <shai@platonix.com>, 443600@bugs.debian.org, Sune Vuorela <Sune@vuorela.dk>
Subject: Re: Bug#443600: konqueror-nsplugins: I think this was marked done prematurely
Date: Sat, 6 Oct 2007 22:19:48 +0200
[Message part 1 (text/plain, inline)]
On Saturday 06 October 2007, Shai Berger wrote:
> Hi Sune,
>
> Thanks for your clarification about the reason for the 100% CPU. For the
> rest, however,
>
> On Saturday 06 October 2007, Sune Vuorela wrote:
> > nspluginviewer can't initialize any kind of environment that a plugin
> > might or might not use. remember that this is plugins. If a plugin needs
> > something special, then that something needs to do it.
>
> Well, "ns" in nspluginviewer stands for NetScape, as far as I'm aware

Correct.

> doubt that GTK can be regarded as "something special". My understanding is
> that it should strive to make the plugin feel as if it is being run by
> netscape (or at least Gecko),

Actually no, the plugin API does not specify any particual rendering engine or 
browser technology. 

> > either the bug could be fixud at it roots (=in adobe) or worked around
> > where "special things" are needed (=gtk).
>
> I beg to differ twice. Adobe wrote a library to work in GTK applications,
> so not initializing GTK in the library cannot be called a bug. From their
> point of view, the plugin works perfectly in all environments where it was
> designed to work.

Adobe wrote a plugin for an application supporting the Netscape Plugin API.
Since this API does not in any way specify that GTK is used for the APIs 
implementation, they can not assume this.

Based on the API they can assume that the host application is having a Motif 
compatible event loop. Any plugin implementor therefore has to make sure 
other internal requirements are setup correctly in their code.

> GTK is also perfectly within their turf when they decide the meaning of
> their own API.

No argument about that. Especially since gtk_init() is specified to be allowed 
to be called multiple times, where the first call will perform the 
initialization and every other call will basically be a no-op.

There is no reason for the Adobe plugin not to call it.

> The only problem is when a non-gtk application insists it can call gtk
> libraries without initialization. Essentially, nspluginviewer has broken
> the API's contract, and is now paying the consequences (or rather, the
> users are).

nspluginviewer doesn't use GTK, therefore can hardly have broken that API's 
contract.
It fully implements the requirements of the NS Plugin API, thus not breaking 
this contract either.

Adobe's QA has probably failed to detect the missing initialization, thus 
making the plugin break the GTK API contract

> > (And firefox and other gtk browsers works because they *tada* are gtk
> > browsers - making konqueror a gtk browser isn't a choice we want to take)
>
> While I understand and praise this desire for purity, I think it makes
> little sense when loading plugins designed for a GTK browser -- which is,
> after all, the whole point of nspluginviewer's existence, and more so, its
> existence as a separate entity. In essence, by choosing to use the plugin,
> the user has already told you they aren't interested in such purity.

Well, as I wrote above, the plugin is not designed for a GTK browser. Even if 
it were designed for Firefox, which it isn', it wouldn't be designed for one.
Firefox, including Gecko, does not depend on GTK but rather uses a kind of 
abstraction toolkit made by Mozilla so they can implement it differently 
depending on platform.

> I also understand the reluctance to include a dependency on GTK at the
> heart of KDE -- perhaps this means nspluginviewer should be taken out of
> kdebase. However, what you're doing now is try to tell the writers of
> plugins for Gecko-based browsers that there's a special, added requirement
> for their plug-in to work in konqueror. I think this won't fly.

While it would be nice to have different plugin runners for plugins with 
different toolkit requirements, there is currently no way a browser can ask a 
plugin which toolkit it requires.

This might be changed in a newer version of the plugin API, e.g. like it can 
decide which MIME type a plugin is capable of handling. Until then a plugin's 
toolkit requirements is an implementation detail the plugin itself has to 
take care of, since neither the browser nor its plugin runner can.

It's not a good idea for plugin hosts to work around bugs in plugins, because 
it will likely end up in a situation where a workaround for one plugin breaks 
another.
Especially in cases where the bug is trivial to fix for the plugin creator.

Cheers,
Kevin
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Shai Berger <shai@platonix.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 443600@bugs.debian.org (full text, mbox):

From: Shai Berger <shai@platonix.com>
To: 443600@bugs.debian.org, Kevin Krammer <kevin.krammer@gmx.at>
Cc: Sune Vuorela <Sune@vuorela.dk>
Subject: Re: Bug#443600: konqueror-nsplugins: I think this was marked done prematurely
Date: Sun, 07 Oct 2007 00:07:27 +0200
On Saturday 06 October 2007, Kevin Krammer wrote:
>
> Adobe wrote a plugin for an application supporting the Netscape Plugin API.
> Since this API does not in any way specify that GTK is used for the APIs
> implementation, they can not assume this.
>

With this, I stand corrected on all claims about nspluginviewer.




Severity set to `important' from `normal' Request was from "Dwayne C. Litzenberger" <dlitz@dlitz.net> to control@bugs.debian.org. (Sun, 14 Oct 2007 19:00:08 GMT) Full text and rfc822 format available.

Merged 443399 443600. Request was from "Dwayne C. Litzenberger" <dlitz@dlitz.net> to control@bugs.debian.org. (Sun, 14 Oct 2007 19:00:09 GMT) Full text and rfc822 format available.

Bug reopened, originator not changed. Request was from "Dwayne C. Litzenberger" <dlitz@dlitz.net> to control@bugs.debian.org. (Sun, 14 Oct 2007 20:18:06 GMT) Full text and rfc822 format available.

Tags added: patch Request was from "Dwayne C. Litzenberger" <dlitz@dlitz.net> to control@bugs.debian.org. (Sun, 14 Oct 2007 20:18:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#443600; Package konqueror-nsplugins. Full text and rfc822 format available.

Acknowledgement sent to Raúl Sánchez Siles <rss@barracuda.es>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #48 received at 443600@bugs.debian.org (full text, mbox):

From: Raúl Sánchez Siles <rss@barracuda.es>
To: 443399@bugs.debian.org, 443600@bugs.debian.org, 443399-done@bugs.debian.org, 443600-done@bugs.debian.org
Subject: Bug fixed in libgtk2.12.0-3
Date: Mon, 15 Oct 2007 13:28:34 +0200
  Hello All:

  This bug have been close by libgtk maintainers and hence using 2.12.0-3 
version of the gtk packages the problem shouldn't be seen any more (yet it 
will exist)

  Regards
-- 
Raúl Sánchez Siles




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 13 Nov 2007 07:25:06 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 03:07:18 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.